RCE = CreateFrame("Frame")

local type = type
local select = select
local error = error

RCE_RegisteredObjects = {}

function RCE:HandleCombatEvent(self, time, eventType, ...)
	for object, data in pairs(RCE_RegisteredObjects) do
		if data[eventType] then
			local sucess, error = pcall(data[eventType], object, time, ...)
			if not sucess then
				geterrorhandler()(error)
			end
		end
	end
end

function RCE:Embed(object)
	object.RegisterCombatEvent = RegisterCombatEvent
	object.RegisterCombatEvents = RegisterCombatEvents
	object.IsCombatEventRegistered = IsCombatEventRegistered
	RCE_RegisteredObjects[object] = {}
end

function RegisterCombatEvent(self, event, func)
	if not RCE_RegisteredObjects[self] then
		RCE_RegisteredObjects[self] = {}
	end
	RCE_RegisteredObjects[self][event] = func
end

function RegisterCombatEvents(self, ...)
	if not RCE_RegisteredObjects[self] then
		RCE_RegisteredObjects[self] = {}
	end
	
	local func
	if type(select(select("#", ...), ...)) == "function" then
		func = select(select("#", ...), ...)
	else
		error(format("Bad argument #"..select("#", ...).." to RegisterCombatEvents (function expected, got %s)", type(select(select("#", ...), ...))))
	end	

	for i=1, select("#", ...) do
		if type(select(i, ...)) == "string" then
			RCE_RegisteredObjects[self][select(i, ...)] = func
		end
	end
end

function IsCombatEventRegistered(self, event)
	if RCE_RegisteredObjects[self] and RCE_RegisteredObjects[self][event] then
		return true
	end
	return false
end
	
RCE:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
RCE:SetScript("OnEvent", RCE.HandleCombatEvent)